package com.twilio.sdk.type;

import org.junit.Assert;
import org.junit.Test;

import java.io.IOException;

/**
 * Test class for {@link PhoneNumberPrice}.
 */
public class PhoneNumberPriceTest extends TypeTest {

    @Test
    public void testFromJson() throws IOException {
        String json = "{\n" +
            "    \"base_price\": 1.00,\n" +
            "    \"current_price\": 2.00,\n" +
            "    \"type\": \"mobile\"\n" +
            "}";

        PhoneNumberPrice pnp = fromJson(json, PhoneNumberPrice.class);
        Assert.assertEquals(1.00, pnp.getBasePrice(), 0.00);
        Assert.assertEquals(2.00, pnp.getCurrentPrice(), 0.00);
        Assert.assertEquals(PhoneNumberPrice.Type.MOBILE, pnp.getType());
    }

}
